﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

namespace EmailSend.Class
{
    public class FillDropdownList
    {
        #region Criando Variaveis Internas
            private DropDownList _ddl;
            private string _ddlText;
            private string _ddlValue;
            private string _nodeElement;
            private string _urlXml;
            private string _textDefault;
        #endregion

        /// <summary>    
        /// Obter ou alterar o nome do campo que irá preencher o texto dos itens    
        /// </summary>    
            public string DDLText 
            { get { return _ddlText; } 
              set { _ddlText = value; } 
            }

        /// <summary>    
        /// Obter ou alterar o nome do campo que irá preencher o valor dos itens    
        /// </summary>    
            public string DDLValue 
            { get { return _ddlValue; } 
              set { _ddlValue = value; } 
            }

        /// <summary>    
        /// Obter ou alterar o endereço do ficheiro xml a ser lido    
        /// </summary>    
            public string UrlXml 
            { get { return _urlXml; } 
              set { _urlXml = value; } 
            }

        /// <summary>    
        /// Obter ou alterar o nome dos elementos que vão ser lidos    
        /// </summary>    
            public string NodeElement 
            { get { return _nodeElement; } 
              set { _nodeElement = value; } 
            }

        /// <summary>    
        /// Método construtor    
        /// </summary>    
        /// <param name="dropdown">Dropdown a ser preenchida</param>    
        /// <param name="urlXml">Endereço do xml a ser lido</param>    
        /// <param name="fieldText">Campo que possui o valor dos itens</param>    
        /// <param name="fieldValue">Campo que possui o texto dos itens</param>    
        /// <param name="nodeElement">Identificação do elemento onde estão guardados os itens a processar</param>    
            public FillDropdownList(DropDownList dropdown, string urlXml, string fieldText, string fieldValue, string nodeElement, string textDefault)
        {
            this._ddl = dropdown;
            this._ddlText = fieldText;
            this._ddlValue = fieldValue;
            this._urlXml = urlXml;
            this._nodeElement = nodeElement;
            this._textDefault = textDefault;
        }

        /// <summary>    
        /// Preencher DropdownList    ///     
        /// nota: o tratamento de erros deverá ser mais elaborado ...    
        /// </summary>    
            public void FillDropdown()
        {
            DataSet dataSet = new DataSet();
            dataSet = new DataSet(this._nodeElement);
            dataSet.ReadXml(this._urlXml);
            this._ddl.DataSource        = dataSet.Tables[this._nodeElement];
            this._ddl.DataTextField     = this._ddlText;
            this._ddl.DataValueField    = this._ddlValue;
            this._ddl.DataBind();

            if (this._textDefault.Length <= 0)
            { this._ddl.Items.Insert(0, new ListItem("(escolha um item)", "")); }
            else
            { this._ddl.Items.Insert(0, new ListItem(this._textDefault, "")); }
            dataSet.Dispose();
        }
    }
}
